require 'commander'

module Salt
  class CLI
    include Commander::Methods

    def run
      program :name, 'Salt'
      program :version, Salt::VERSION
      program :description, 'Compiles and/or runs salt programs.'

      compile_command
      lint_command
      run_command

      run!
    end

    private

    def compile_command
      command :compile do |command|
        command.syntax = 'salt compile'
        command.description = 'Compiles the given file.'
        command.option '-f STRING', '--file STRING', String,
          'The file to compile.'

        command.action do |_, options|
          p options
        end
      end
    end

    def lint_command
    end

    def run_command
    end
  end
end
